#ifndef MSP_DATAFILE_INPUT_H_
#define MSP_DATAFILE_INPUT_H_

#include <msp/core/noncopyable.h>
#include <msp/io/base.h>

namespace Msp {
namespace DataFile {

class Input: private NonCopyable
{   
private:
	IO::Base *in;
	IO::Base *compressed;
	unsigned line;
	int next;

public:
	Input(IO::Base &); 
	~Input();

	void set_decompress();
	int get();
	int peek();
	unsigned get_line_number() const { return line; }
	explicit operator bool() const;
};  

} // namespace DataFile
} // namespace Msp

#endif
